class DelegationController < ApplicationController
  def create

    h = {}
    request.headers.env.select{|k, _| k.in?(ActionDispatch::Http::Headers::CGI_VARIABLES) || k =~ /^HTTP_/}.each do |k, v|
      key = k.split("_").map(&:capitalize).reject { _1 == "Http" }.join("-")
      h[key] = v
    end

    p = params.permit!.to_h

    p.delete("delegation")
    endpoint = p.delete("_delegation_endpoint")
    method = p.delete("_delegation_method")
    module_id = p.delete("_delegation_module_id")

    module_id = "rx_universe_api" if module_id == "rxuniverse_api"
    component = Component.resolve(module_id)

    encoded_parameters = [:post, :put, :patch].include?(method.to_sym) ? p.to_json : p

    r = RxModule::Communicator.client.send(method, component.resolve_endpoint(endpoint), encoded_parameters, h)

    is_json = r.headers["content-type"]&.include?("application/json")
    if is_json
      render json: JSON.parse(r.body), status: r.status
    else
      render plain: r.body, status: r.status
    end

  end
end
