class Oauth2Controller < ApplicationController
  before_action :set_user

  def rxuniverse
    rxuniverse_module = RxUniverseApiComponent.first

    if rxuniverse_module.nil? || @user.nil?
      render nothing: true, status: 404
    else
      conn = Faraday.new(rxuniverse_module.oauth2_token_url, ssl: {
        verify: !RxModule::Communicator.skip_ssl_validation
      })
      response = conn.post(nil, JSON.generate({code: params[:code]}))
      OAuth.load_from_text_resp(@user, :rxuniverse, response.body)
      redirect_to "/api/oauth2/success"
    end
  end

  private

  def set_user
    @user = User.find(params[:user_id])
  end
end
