import * as React from 'react';
import {TableCell, TableRow} from "@material-ui/core";
import {t} from "@lingui/macro";
import {UpdateCell} from "./UpdateCell";
import {RxModuleComponentModel} from "../../../stores/RxModuleComponentStore";
import {Model} from "@rx-suite/data";
import {observer} from "mobx-react-lite";
import {HintButton} from "@rx-suite/ui";

type Props = {
    model: Model
}

export const UpdateAvailableTableRow: React.FunctionComponent<Props> = observer(({model}) => {
    const updateInfo = React.useMemo(() => {
        return (model.updateText as string).split("\n").map((v: string) =>
            <React.Fragment key={v}>
                {v}
                <br/>
            </React.Fragment>
        )
    }, [model.updateText]);

    return (
        <>
            <TableRow>
                <TableCell>{t`Update Info`}</TableCell>
                <TableCell>{updateInfo}</TableCell>
            </TableRow>
            <TableRow>
                <TableCell>{t`Perform Update`}</TableCell>
                <TableCell><UpdateCell allowReinstall={true} model={model as RxModuleComponentModel}/></TableCell>
            </TableRow>
        </>
    )
});