import * as React from "react";
import {observer} from "mobx-react-lite";
import {Schedule, ShiftModel} from "../../../stores/ShiftStore";
import {makeStyles} from "@material-ui/core/styles";
import {IconButton} from "@material-ui/core";
import {runInAction} from "mobx";
import {Delete} from "@material-ui/icons";

const useStyles = makeStyles(theme => ({
    danger: {
        color: theme.palette.error.main
    }
}));

export const DeleteRuleButton: React.FunctionComponent<{ shift: ShiftModel, schedule: Schedule, scheduleIndex: number, readOnly?: boolean }> = observer(({
                                                                                                                                                             shift,
                                                                                                                                                             schedule,
                                                                                                                                                             readOnly
                                                                                                                                                         }) => {
    const classes = useStyles();
    const onClick = React.useCallback(() => {
        runInAction(() => {
            shift.viewModel.shift_schedules = shift.viewModel.shift_schedules.filter(s => s !== schedule);
        });
    }, [shift, schedule]);
    return (
        <IconButton disabled={readOnly} onClick={onClick}>
            <Delete className={readOnly ? undefined : classes.danger}/>
        </IconButton>
    );
});