import * as React from 'react';
import {CurrentUserStore} from "@rx-suite/stores/build";
import {LinearProgress} from "@material-ui/core";
import {UserForm} from "../users/UserForm";
import {UserStore} from "../../stores/UserStore";
import {observer} from "mobx-react-lite";

export const ProfileSettings = observer(() => {
    if (!CurrentUserStore.selectedModel) {
        return <LinearProgress/>;
    }
    const user = UserStore.get(CurrentUserStore.selectedModel.id);
    if (!user) {
        return <LinearProgress/>
    }
    return (
        <UserForm model={user} profileMode/>
    )
});